// Con Clase Agosto 2023
// Ejemplo de generacin de cdigo QR
// Salvador Pozo
// Nota: si en la consola se usa el texto blanco sobre fondo negro
// el cdigo estar invertido y el cdigo no ser lejible.
// Se puede corregir esto de varios modos:
// - Intercambiar los espacios y los dots (aunque habra que aadir
//   dots extras alrededor del cdigo.
// - Modificar los colores asignados a las propiedades de la consola.
// - La ms sencilla, seleccionar el texto de la consola, que invierte
//   los colores.
// La versin elegida para este ejemplo es vlida para el enlace
// usado como texto. Textos ms largos, o niveles de correccin de
// errores mayores requerirn, probablemente, versiones mayores.
// Esta librera puede generar cdigos QR que no pueden ser ledos
// si se selecciona una versin menor que la necesaria para contener
// los datos indicados.

#include <iostream>
#include "qrcode.h"

using namespace std;

int main() {
    // Estructura para manejar cdigo QR
    QRCode qrcode;
    uint8_t *qrcodeBytes;
    const int version=2;
    char *dot="\333\333";
    char *esp="  ";

    // Obtener un trozo de memoria para almacenar el cdigo QR
    qrcodeBytes = new uint8_t[qrcode_getBufferSize(version)];

    // Generar un cdigo QR a partir de una cadena:
    qrcode_initText(&qrcode, qrcodeBytes, version, ECC_LOW, "https://conclase.net");

    // Mostrar cdigo QR en modo texto:
    for (int y = 0; y < qrcode.size; y++) {
        for (int x = 0; x < qrcode.size; x++) {
            if(qrcode_getModule(&qrcode, x, y)) {
                cout << dot;
            } else {
                cout << esp;
            }
        }
        cout << endl;
    }
    delete[] qrcodeBytes;

    return 0;
}
